Bug 1693771 - erlang-rpm-macros: Switch to a string for RPM calls (oncoming rpm API fix change)
Summary: erlang-rpm-macros: Switch to a string for RPM calls (oncoming rpm API fix cha...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: erlang-rpm-macros
Version: 31
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Peter Lemenkov
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1693751 1779194
TreeView+ depends on / blocked
 
Reported: 2019-03-28 15:25 UTC by Panu Matilainen
Modified: 2019-12-03 13:47 UTC (History)
2 users (show)

Fixed In Version: erlang-rpm-macros-0.3.1-1.fc30 erlang-rpm-macros-0.3.1-1.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-09-08 02:59:01 UTC
Type: Bug


Attachments (Terms of Use)

Description Panu Matilainen 2019-03-28 15:25:53 UTC
Description of problem:

Rpm's python3 API has been totally braindamaged all this time but people are only noticing now that it's starting to get used. 

We're changing rpm to return all string data as surrogate-escaped utf-8 python strings everywhere (instead of bytes with unknown encoding that the API doesn't otherwise even accept, see bug 1631292). This makes most rpm-scripts written for python2 just work with python3 too (from the rpm pov).

Most software that has kept python2 compatibility are automatically compatible with the fixed API, but unfortunately python3-only users need fixing for the new behavior.

There's at least one place in erlang-rpm-macros that is affected, there's an explicit .decode() of rpm data in inspect_beam_file() function.

As the broken rpm versions are widely in use, it's best to keep compatibility with both initially. Basically replace all the hardcoded .decode("utf-8") calls to header data with something like this:

def b2s(data):
    if isinstance(data, bytes):
        return data.decode('utf-8')
    return data

Comment 1 Panu Matilainen 2019-03-29 07:09:25 UTC
I was pointed out that the bug referred to in the message is a private RHEL bug, sorry about that. 
The public, Fedora side counterpart with the background story is the one blocked by this, ie 
https://bugzilla.redhat.com/show_bug.cgi?id=1693751

Comment 2 Ben Cotton 2019-08-13 16:56:59 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 3 Ben Cotton 2019-08-13 19:26:51 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 4 Fedora Update System 2019-08-30 17:18:27 UTC
FEDORA-2019-354452ca73 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-354452ca73

Comment 5 Fedora Update System 2019-08-30 20:33:14 UTC
erlang-rpm-macros-0.3.1-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-cdd96c2958

Comment 6 Fedora Update System 2019-08-31 01:04:06 UTC
erlang-rpm-macros-0.3.1-1.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-354452ca73

Comment 7 Fedora Update System 2019-09-08 02:59:01 UTC
erlang-rpm-macros-0.3.1-1.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2019-09-14 00:08:05 UTC
erlang-rpm-macros-0.3.1-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2019-09-14 16:32:01 UTC
erlang-rpm-macros-0.3.1-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.